import { readable, writable } from 'svelte/store';

type IntroIndex = number;

interface MemberStore {
   username: string
   intros: IntroIndex[]
}

interface Intro {
    name: string
    filename: string
    length: number
}

function createMemberStore(): MemberStore {
    const { subscribe, set, update } = writable(null)

    return {
        subscribe: subscribe,
        set: set,
        addIntro: (intro: IntroIndex) => { update((n) => n.intros.push(intro)); return intro },
        _fakeLogin: async (username) => {
            const response = (await (await fetch(`http://localhost:7756/me/${username}`)).json())

            if (response === "NoUserFound") {
                return false;
            } else {
                set(response.Me) 

                return true;
            }
        },
    }
}

function createIntroStore(): IntroStore {
    const { subscribe, set, update } = writable([])

    return {
        subscribe: subscribe,
        set: set,
        update: update,
        fetchIntros: async () => {
            const response = (await (await fetch("http://localhost:7756/intros/588149178912473103")).json())
            if (response !== "NoGuildFound") {
                console.log(response.Intros[0].File);
                const intros = response.Intros.map((intro) => {
                    if (!!intro.File) {
                        return { name: intro.File.friendlyName, filename: intro.File.filename }
                    } else if (!!intro.Online) {
                        return { name: intro.Online.friendlyName, url: intro.Online.url }
                    }
                })
                console.log(intros)

                set(intros)
            }
        },
    }


}

export const intros: IntroStore = createIntroStore()
export const member: MemberStore = createMemberStore()

